import 'dart:async';

import 'package:flutter/services.dart';

class Adgydeflutterplugin {
  static const MethodChannel instance = const MethodChannel('adgydeplugin');
  String deeplink="";  String userId=""; String campaignName=""; int campaignId ; String channelName ="";
  int channelId ; String mediaSource=""; String utmSource="";

  void init(String appkey,String channel) {
    instance.invokeMethod("init",<String, dynamic>{'appkey':appkey,'channel': channel});
  }

  void simpleEvent(String eventValue) {
    instance.invokeMethod("simpleEvent",eventValue);
  }

  void countingEvent(String eventId, Map eventValue) {
    instance.invokeMethod("countingEvent",<String, dynamic>{'eventId':eventId,'eventValue': eventValue});
  }

  void computingEvent(String eventId, Map eventValue) {
    instance.invokeMethod("computingEvent", <String, dynamic>{'eventId':eventId,'eventValue': eventValue});
  }

  void daliyUnique(String eventId, Map eventValue) {
    instance.invokeMethod("daliyUnique",<String, dynamic>{'eventId':eventId,'eventValue': eventValue});
  }

  void permanentUnique(String eventId, Map eventValue) {
    instance.invokeMethod("permanentUnique",<String, dynamic>{'eventId':eventId,'eventValue': eventValue});
  }

  void customUnique(String eventId, Map eventValue,int time) {
    instance.invokeMethod("customUnique",<String, dynamic>{'eventId':eventId,'eventValue': eventValue,'time': time});
  }
  void setCurrentScreen(String screenName) {
    instance.invokeMethod("setCurrentScreen",screenName);
  }

  void removeCurrentScreen(String screenName) {
    instance.invokeMethod("removeCurrentScreen",screenName);
  }

  void getEmailId(String emailId) {
    instance.invokeMethod("getEmailId",emailId);
  }

  void getPhoneNumber(int phoneno) {
    instance.invokeMethod("getPhoneNumber",phoneno);
  }

  void setClientUserId(String clientUserid) {
    instance.invokeMethod("setClientUserId",clientUserid);
  }

  void revenueEvent(int revenue) {
    instance.invokeMethod("revenueEvent",revenue);
  }

  void fcmToken(String token) {
    instance.invokeMethod("fcmToken",token);
  }

  void setAge(String age) {
    instance.invokeMethod("setAge",age);
  }

  void setGender(String gender) {
    instance.invokeMethod("setGender",gender);
  }

  bool setImeiPermission(bool imei) {
    instance.invokeMethod("setIMEIPermission",imei);
  }

 void getDeeplinkData() async {
    try {
      final String result = await instance.invokeMethod('getDeeplinking');
      deeplink = result;
    } on PlatformException catch (e) {
      deeplink = "Failed to Invoke: '${e.message}'.";
    }
  }

  void getUserId() async {
    try {
      final String result = await instance.invokeMethod('getUserId');
      userId = result;
    } on PlatformException catch (e) {
      userId = "Failed to Invoke: getUserId '${e.message}'.";
    }
  }
  void getCampaignName() async{
    try {
      final String result = await instance.invokeMethod('getCampaignName');
     campaignName = result;
    } on PlatformException catch (e) {
      campaignName = "Failed to Invoke: getCampaignName'${e.message}'.";
    }

  }

  void getCampaignId() async{
    try {
      final int result = await instance.invokeMethod('getCampaignId');
      campaignId = result;
    } on PlatformException catch (e) {
      //campaignId = "Failed to Invoke: getCampaignId'${e.message}'.";
    }

  }

  void getChannelName() async{
    try {
      final String result = await instance.invokeMethod('getChannelName');
      channelName = result;
    } on PlatformException catch (e) {
      channelName = "Failed to Invoke: getChannelName'${e.message}'.";
    }

  }
  void getchannelId() async{
    try {
      final int result = await instance.invokeMethod('getChannelId');
      channelId = result;
    } on PlatformException catch (e) {
      e.message;
    }

  }

  void getMediaSource() async{
    try {
      final String result = await instance.invokeMethod('getMediaSource');
      mediaSource = result;
    } on PlatformException catch (e) {
      mediaSource = "Failed to Invoke: getMediaSource'${e.message}'.";
    }

  }

  void getUtmSource() async{
    try {
      final String result = await instance.invokeMethod('getUtmSource');
      utmSource = result;
    } on PlatformException catch (e) {
      utmSource = "Failed to Invoke: getUtmSource'${e.message}'.";
    }

  }
}
